﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;

public partial class Default2 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        RadEditor1.ImageManager.ViewPaths = new string[] { "~/" };
        RadEditor1.ImageManager.UploadPaths = new string[] { "~/" };
        RadEditor1.ImageManager.ContentProviderTypeName = typeof(myprovider).AssemblyQualifiedName;
    }


    protected override void OnPreRenderComplete(System.EventArgs e)
    {
        base.OnPreRenderComplete(e);

        // Change the height of the ImageDialog
        DialogDefinition imagePropertiesDialog = RadEditor1.GetDialogDefinition("ImageManager");
        imagePropertiesDialog.Height = Unit.Pixel(600);
    }

    public class myprovider : Telerik.Web.UI.Widgets.FileSystemContentProvider
    {

        public myprovider(HttpContext context, string[] searchPatterns, string[] viewPaths, string[] uploadPaths, string[] deletePaths, string selectedUrl, string selectedItemTag)
            : base(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, selectedItemTag)
        {
        }

        public override string StoreFile(UploadedFile file, string path, string name, params string[] arguments)
        {
            System.Drawing.Image image = System.Drawing.Image.FromStream(file.InputStream);
            string physicalPath = Context.Server.MapPath(path);
            Page page = HttpContext.Current.Handler as Page;// get the Page object of 'customControl.ascx'
            int newWidth = 100;// Default values
            int newHeight = 100;

            if (page != null)
            {
                // try/catch blocks are missing ;

                TextBox tbWidth = page.FindControl("TextBoxWidth") as TextBox;
                newWidth = int.Parse(tbWidth.Text);

                TextBox tbHeight = page.FindControl("TextBoxHeight") as TextBox;
                newHeight = int.Parse(tbHeight.Text);
            }

            System.Drawing.Image resultImage = ResizeImage(image, new Size(newWidth, newHeight));
            resultImage.Save(physicalPath + name);

            string result = path + name;
            return result;
        }

        private static System.Drawing.Image ResizeImage(System.Drawing.Image sourceImage, Size newSize)
        {
            Bitmap bitmap = new Bitmap(newSize.Width, newSize.Height);
            Graphics g = Graphics.FromImage((System.Drawing.Image)bitmap);
            g.InterpolationMode = InterpolationMode.HighQualityBicubic;

            g.DrawImage(sourceImage, 0, 0, newSize.Width, newSize.Height);
            g.Dispose();

            return (System.Drawing.Image)bitmap;
        }
    }

}
